Summary:        XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
Name:           xmlrpc-c
Version:        1.54.05
Release:        7%{?dist}
License:        BSD and MIT
URL:            http://xmlrpc-c.sourceforge.net/
Source0:	https://download.sourceforge.net/project/xmlrpc-c/Xmlrpc-c%20Super%20Stable/%{version}/%{name}-%{version}.tgz
Patch0001:	0001-xmlrpc_server_abyss-use-va_args-properly.patch
Patch0002:	0002-Use-proper-datatypes-for-long-long.patch
Patch0003:	0003-allow-30x-redirections.patch
# https://pagure.io/koji/issue/3314
# fix 'dumpVakue' symlink error when using koji.
Patch5000:	5000-fix-dumpvakue-symlink-in-koji.patch


BuildRequires:  gcc, gcc-c++, openssl-devel, libcurl-devel, readline-devel, ncurses-devel, git-core

Provides:       bundled(expat)

%description
XML-RPC is a quick-and-easy way to make procedure calls over the Internet. It converts the procedure call into an XML document, sends it to a remote server using HTTP, and gets back the response as XML.

%package c++
Summary:        C++ libraries for xmlrpc-c
Requires:       %{name} = %{version}-%{release}

%description c++
XML-RPC is a quick-and-easy way to make procedure calls over the Internet. It converts the procedure call into an XML document, sends it to a remote server using HTTP, and gets back the response as XML.

This library provides a modular implementation of XML-RPC for C++.

%package client
Summary:        C client libraries for xmlrpc-c
Requires:       %{name} = %{version}-%{release}

%description client
XML-RPC is a quick-and-easy way to make procedure calls over the
Internet. It converts the procedure call into XML document, sends it
to a remote server using HTTP, and gets back the response as XML.

This library provides a modular implementation of XML-RPC for C
clients.

%package client++
Summary:        C++ client libraries for xmlrpc-c
Requires:       %{name} = %{version}-%{release}
Requires:       %{name}-c++ = %{version}-%{release}
Requires:       %{name}-client = %{version}-%{release}

%description client++
XML-RPC is a quick-and-easy way to make procedure calls over the
Internet. It converts the procedure call into XML document, sends it
to a remote server using HTTP, and gets back the response as XML.

This library provides a modular implementation of XML-RPC for C++
clients.

%package devel
Summary:        Development files for xmlrpc-c based programs
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       %{name}-c++%{?_isa} = %{version}-%{release}
Requires:       %{name}-client%{?_isa} = %{version}-%{release}
Requires:       %{name}-client++%{?_isa} = %{version}-%{release}

%description devel
Static libraries and header files for writing XML-RPC applications in
C and C++.

%package apps
Summary:        Sample XML-RPC applications
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       %{name}-c++%{?_isa} = %{version}-%{release}
Requires:       %{name}-client%{?_isa} = %{version}-%{release}
Requires:       %{name}-client++%{?_isa} = %{version}-%{release}

%description apps
XML-RPC is a quick-and-easy way to make procedure calls over the
Internet. It converts the procedure call into XML document, sends it
to a remote server using HTTP, and gets back the response as XML.

This package contains some handy XML-RPC demo applications.



%prep
%autosetup -Sgit



%build
%configure
%make_build
(cd lib/openssl && make %{?_smp_mflags})
(cd tools && make %{?_smp_mflags})



%check
make check

%install
%make_install
(cd lib/openssl && make install prefix=/usr DESTDIR=%{buildroot})
(cd tools && make install prefix=/usr DESTDIR=%{buildroot})
rm -rf %{buildroot}/%{_libdir}/*.a



%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig
%post client -p /sbin/ldconfig
%postun client -p /sbin/ldconfig
%post c++ -p /sbin/ldconfig
%postun c++ -p /sbin/ldconfig
%post client++ -p /sbin/ldconfig
%postun client++ -p /sbin/ldconfig



%files
%license doc/COPYING lib/abyss/license.txt
%doc doc/CREDITS doc/HISTORY
%{_libdir}/libxmlrpc_xml*.so.*
%{_libdir}/libxmlrpc_openssl.so.*
%{_libdir}/libxmlrpc.so.*
%{_libdir}/libxmlrpc_util.so.*
%{_libdir}/libxmlrpc_abyss.so.*
%{_libdir}/libxmlrpc_server.so.*
%{_libdir}/libxmlrpc_server_abyss.so.*
%{_libdir}/libxmlrpc_server_cgi.so.*

%files client
%{_libdir}/libxmlrpc_client.so.*

%files c++
%{_libdir}/libxmlrpc_cpp.so.*
%{_libdir}/libxmlrpc++.so.*
%{_libdir}/libxmlrpc_util++.so.*
%{_libdir}/libxmlrpc_abyss++.so.*
%{_libdir}/libxmlrpc_server++.so.*
%{_libdir}/libxmlrpc_server_abyss++.so.*
%{_libdir}/libxmlrpc_server_cgi++.so.*
%{_libdir}/libxmlrpc_packetsocket.so.*
%{_libdir}/libxmlrpc_server_pstream++.so.*

%files client++
%{_libdir}/libxmlrpc_client++.so.*

%files devel
%{_bindir}/xmlrpc-c-config
%{_includedir}/xmlrpc-c/
%{_includedir}/*.h
%{_libdir}/pkgconfig/xmlrpc*.pc
%{_libdir}/libxmlrpc*.so

%files apps
%{_bindir}/xmlrpc_parsecall
%{_bindir}/xmlrpc
%{_bindir}/xmlrpc_transport
%doc tools/xmlrpc_transport/xmlrpc_transport.html
%{_bindir}/xml-rpc-api2cpp
%{_mandir}/man1/xml-rpc-api2cpp.1*
%{_bindir}/xml-rpc-api2txt
%{_mandir}/man1/xml-rpc-api2txt.1*
%{_bindir}/xmlrpc_cpp_proxy
%{_bindir}/xmlrpc_pstream
%{_bindir}/xmlrpc_dumpserver

%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.54.05-7
- Rebuilt for loongarch release

* Wed May 29 2024 Shuo Wang <abushwang@tencent.com> - 1.54.05-6
- enable %check

* Thu Oct 12 2023 Miaojun Dong <zoedong@tencent.com> - 1.54.05-5
- Rebuild for curl-8.4.0

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.54.05-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.54.05-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.54.05-2
- Rebuilt for OpenCloudOS Stream 23

* Wed Apr 27 2022 Zhao Zhen <jeremiazhao@tencent.com> - 1.54.05-1
- Initial build.

